function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["value", "onChange", "type"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useMemo, useState, useCallback } from 'react';
import { Input, Modal, Form } from 'antd';
import { isString } from '@pisell/utils';
import { GlobalOutlined } from '@ant-design/icons';
import classNames from 'classnames';
import useEngineContext from "../../hooks/useEngineContext";
import { checkIfAllValuesAreEqual, createTranslationText, locales } from "./utils";
import "./index.less";
var defaultGlobal = {
  shopLanguages: {
    primary: 'en',
    list: [{
      id: 1,
      code: 'zh-CN',
      text: '简体中文',
      primary: 1,
      status: 'published'
    }, {
      id: 2,
      code: 'en',
      text: 'English',
      primary: 0,
      status: 'published'
    }, {
      id: 3,
      code: 'zh-HK',
      text: '繁體中文',
      primary: 0,
      status: 'published'
    }, {
      id: 4,
      code: 'ja',
      text: '日本語',
      primary: 0,
      status: 'published'
    }, {
      id: 5,
      code: 'pt',
      text: 'Português',
      primary: 0,
      status: 'published'
    }]
  },
  primary_locale: 'en'
};
var defaultObj = {};
var Translation = function Translation(props) {
  var _context$appHelper, _store$getState;
  var _props$value = props.value,
    value = _props$value === void 0 ? defaultObj : _props$value,
    onChange = props.onChange,
    _props$type = props.type,
    type = _props$type === void 0 ? 'text' : _props$type,
    others = _objectWithoutProperties(props, _excluded);
  var context = useEngineContext();
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(value),
    _useState4 = _slicedToArray(_useState3, 2),
    _value = _useState4[0],
    set_value = _useState4[1];
  var store = context === null || context === void 0 || (_context$appHelper = context.appHelper) === null || _context$appHelper === void 0 ? void 0 : _context$appHelper.store;
  var _ref = (store === null || store === void 0 || (_store$getState = store.getState()) === null || _store$getState === void 0 ? void 0 : _store$getState.global) || defaultGlobal,
    shopLanguages = _ref.shopLanguages;
  var getInputComponent = useCallback(function () {
    console.log(type, props, '翻译组件type值11');
    switch (type) {
      case 'textarea':
        return Input.TextArea;
      default:
        return Input;
    }
  }, [type]);
  var InputComponent = getInputComponent();
  useEffect(function () {
    var _newValue = _objectSpread({}, value);
    if (isString(value)) {
      _newValue = createTranslationText(value);
    }
    set_value(_objectSpread(_objectSpread({}, defaultValue), _newValue));
  }, [value]);
  var currentLocale = useMemo(function () {
    return shopLanguages.primary;
  }, [shopLanguages.primary]);
  var inputValue = useMemo(function () {
    if (isString(value)) {
      return value;
    }
    return value[currentLocale];
  }, [value, currentLocale]);
  var languageList = useMemo(function () {
    return shopLanguages.list;
  }, [shopLanguages.list]);
  var defaultValue = useMemo(function () {
    var obj = {};
    for (var item in locales) {
      obj[item] = '';
    }
    return obj;
  }, []);
  var allChange = function allChange(e) {
    var newValue = _objectSpread(_objectSpread({}, defaultValue), value || {});
    if (checkIfAllValuesAreEqual(newValue)) {
      for (var key in newValue) {
        newValue[key] = e || '';
      }
    } else {
      newValue[currentLocale] = e || '';
    }
    onChange === null || onChange === void 0 || onChange(newValue);
  };
  var isActive = useMemo(function () {
    var bol = false;
    for (var key in value) {
      if (key !== currentLocale && value[key]) {
        bol = true;
      }
    }
    return bol;
  }, [value, currentLocale]);
  var _onOk = function _onOk() {
    onChange === null || onChange === void 0 || onChange(_value);
    setOpen(false);
  };

  /**
   * @title: 多语言图标
   * @description:
   * @param {*} useMemo
   * @return {*}
   * @Author: WangHan
   * @Date: 2025-08-13 14:39
   */
  var suffixIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(GlobalOutlined, {
      className: classNames('pisell-lowcode-translation-icon', {
        active: isActive
      }),
      onClick: function onClick() {
        return setOpen(true);
      }
    });
  }, [isActive]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, type === 'textarea' ? /*#__PURE__*/React.createElement("div", {
    className: "pisell-lowcode-translation-textarea-wrapper"
  }, /*#__PURE__*/React.createElement(InputComponent, _extends({}, others, {
    value: inputValue,
    onChange: function onChange(e) {
      return allChange(e.target.value);
    }
  })), suffixIcon) : /*#__PURE__*/React.createElement(InputComponent, _extends({}, others, {
    value: inputValue,
    onChange: function onChange(e) {
      return allChange(e.target.value);
    },
    suffix: suffixIcon
  })), /*#__PURE__*/React.createElement(Modal, {
    open: open,
    onOk: _onOk,
    onCancel: function onCancel() {
      set_value(value || defaultValue);
      setOpen(false);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "pisell-lowcode-translation-modal"
  }, languageList.map(function (d) {
    return /*#__PURE__*/React.createElement(Form.Item, {
      label: d.text,
      labelCol: {
        span: 24
      },
      key: d.code
    }, /*#__PURE__*/React.createElement(InputComponent, _extends({}, typeof others.maxLength === 'number' ? {
      maxLength: others.maxLength
    } : {}, {
      value: _value[d.code],
      onChange: function onChange(e) {
        set_value(_objectSpread(_objectSpread({}, _value), {}, _defineProperty({}, d.code, e.target.value)));
      },
      autoSize: type === 'textarea' ? others === null || others === void 0 ? void 0 : others.autoSize : undefined
    })));
  }))));
};
export default Translation;